import { mixinColor, mixinDisabled, mixinTabIndex } from '@angular/material/core';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { NG_VALUE_ACCESSOR, FormsModule, FormControl, ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule, MediaObserver } from '@angular/flex-layout';
import { __extends } from 'tslib';
import { CommonModule } from '@angular/common';
import { animate, state, style, transition, trigger, AnimationBuilder, query } from '@angular/animations';
import { ReplaySubject, BehaviorSubject, Subscription, of, EMPTY } from 'rxjs';
import { Attribute, ChangeDetectionStrategy, ChangeDetectorRef, Component, ElementRef, EventEmitter, forwardRef, HostBinding, Input, Output, ViewEncapsulation, NgModule, InjectionToken, Inject, ViewChild, Pipe, Optional, ContentChild, HostListener, Injectable, ViewContainerRef } from '@angular/core';
import { first, map, startWith, delay, switchMap } from 'rxjs/operators';
import { MatMenuTrigger, MatButtonModule, MatDividerModule, MatFormFieldModule, MatIconModule, MatInputModule, MatMenuModule, MatListModule, matSelectAnimations, MatToolbarModule, MatIconRegistry, MatTabsModule } from '@angular/material';
import { TemplatePortal, PortalModule } from '@angular/cdk/portal';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPToggleSwitchChange = /** @class */ (function () {
    function CBPToggleSwitchChange() {
    }
    return CBPToggleSwitchChange;
}());
var CBPToggleSwitchComponentBase = /** @class */ (function () {
    function CBPToggleSwitchComponentBase(_elementRef) {
        this._elementRef = _elementRef;
    }
    return CBPToggleSwitchComponentBase;
}());
/** @type {?} */
var _CBPToggleSwitchMixinBase = mixinTabIndex(mixinColor(mixinDisabled(CBPToggleSwitchComponentBase), 'accent'));
/** @type {?} */
var toggleSwitchCounter = 1;
var CBPToggleSwitchComponent = /** @class */ (function (_super) {
    __extends(CBPToggleSwitchComponent, _super);
    function CBPToggleSwitchComponent(elementRef, _changeDetectorRef, tabIndex) {
        var _this = 
        // tslint:disable-next-line
        _super.call(this, elementRef) || this;
        _this._changeDetectorRef = _changeDetectorRef;
        _this.ariaLabel = '';
        _this.ariaLabelledby = null;
        _this.onValue = true;
        _this.offValue = false;
        _this.onLabel = 'ON';
        _this.offLabel = 'OFF';
        _this.label = '';
        _this.name = null;
        _this.className = 'cbp-toggle-switch';
        _this.id = "cbp-toggle-switch-" + ++toggleSwitchCounter;
        _this._checked = null;
        _this.inputId = _this.id + 'input';
        _this.change = new EventEmitter();
        // just to avoid TypeScript error - it is going to get overwritten by ControlValueAccessor impl of registerOnChange
        _this._controlValueAccessorChangeFn = (/**
         * @return {?}
         */
        function () { });
        _this.tabIndex = Number.parseInt(tabIndex, 10) || 0;
        return _this;
    }
    Object.defineProperty(CBPToggleSwitchComponent.prototype, "required", {
        get: /**
         * @return {?}
         */
        function () {
            return this._required;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._required = value !== null && "" + value !== 'false' && value !== false ? true : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CBPToggleSwitchComponent.prototype, "checked", {
        get: /**
         * @return {?}
         */
        function () {
            return !!this._checked;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.checked) {
                this._checked = value;
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype._getAriaChecked = /**
     * @return {?}
     */
    function () {
        return this._checked === null || this._checked === undefined ? 'mixed' : this._checked ? 'true' : 'false';
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype._stopPropogation = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        $event.stopPropagation();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype._onClick = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        $event.stopPropagation();
        if (!this.disabled) {
            this._checked = !this.checked;
            this._emitChangeEvent();
        }
    };
    /**
     * @private
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype._emitChangeEvent = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var event = new CBPToggleSwitchChange();
        event.source = this;
        event.checked = this.checked;
        this._controlValueAccessorChangeFn(this.checked ? this.onValue : this.offValue);
        this.change.emit(event);
    };
    /**
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} obj
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype.writeValue = /**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        this.checked = obj === this.onValue;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        // for synchronization of values from the downstream components form value
        this._controlValueAccessorChangeFn = fn;
    };
    /**
     * Focus control not implemented yet
     */
    /**
     * Focus control not implemented yet
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype.registerOnTouched = /**
     * Focus control not implemented yet
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    CBPToggleSwitchComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
        this._changeDetectorRef.markForCheck();
    };
    CBPToggleSwitchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-toggle-switch',
                    template: "<input #input\r\n       class=\"cdk-visually-hidden\"\r\n       type=\"checkbox\"\r\n       [id]=\"inputId\"\r\n       [required]=\"required\"\r\n       [checked]=\"checked\"\r\n       [disabled]=\"disabled\"\r\n       [attr.name]=\"name\"\r\n       [tabIndex]=\"tabIndex\"\r\n       [attr.aria-label]=\"ariaLabel\"\r\n       [attr.aria-labelledby]=\"ariaLabelledby\"\r\n       [attr.aria-checked]=\"_getAriaChecked()\"\r\n       (change)=\"_stopPropogation($event)\"\r\n       (click)=\"_onClick($event)\"/>\r\n<label [attr.for]=\"inputId\" [attr.data-on]=\"onLabel\" [attr.data-off]=\"offLabel\">{{ label }}</label>\r\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            // tslint:disable-next-line:no-use-before-declare
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return CBPToggleSwitchComponent; })),
                            multi: true
                        }],
                    preserveWhitespaces: false // seems to trim whitespace content
                    ,
                    styles: [".cbp-toggle-switch{padding-left:64px;overflow:hidden;position:relative}.cbp-toggle-switch>input{-webkit-appearance:none;-moz-appearance:none;appearance:none;position:absolute;width:inherit;height:inherit;opacity:0;left:0;top:0}.cbp-toggle-switch>label{display:inline-block;position:relative;cursor:pointer;font-weight:400;margin-bottom:0}.cbp-toggle-switch>label:before{cursor:pointer;display:inline-block;border-radius:25px;height:25px;width:58px;color:#fff;font-size:10px;font-weight:600;line-height:25px;text-align:center;background:#aaa;transition:background-color .2s ease-out;margin-left:-64px;margin-right:6px;content:attr(data-off);padding-left:20px;padding-right:0}.cbp-toggle-switch>input:checked+label:before{background:#1460aa;content:attr(data-on);padding-right:20px;padding-left:0}.cbp-toggle-switch>input:disabled+label:before{cursor:not-allowed;background:#e6e6e6}.cbp-toggle-switch>input:checked:disabled+label:before{background:#b3c6d2}.cbp-toggle-switch>label:after{cursor:pointer;content:\"\";margin:1px;border-radius:19px;width:19px;height:19px;display:block;background:#fff;position:absolute;top:2px;left:-62px;z-index:2;transition:left .2s ease-out}.cbp-toggle-switch>input:checked+label:after{left:-29px}*,:after,:before{box-sizing:border-box}"]
                }] }
    ];
    /** @nocollapse */
    CBPToggleSwitchComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: ChangeDetectorRef },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] }
    ]; };
    CBPToggleSwitchComponent.propDecorators = {
        ariaLabel: [{ type: Input }],
        ariaLabelledby: [{ type: Input }],
        onValue: [{ type: Input }],
        offValue: [{ type: Input }],
        onLabel: [{ type: Input }],
        offLabel: [{ type: Input }],
        label: [{ type: Input }],
        disabled: [{ type: Input }],
        color: [{ type: Input }],
        name: [{ type: Input }],
        tabIndex: [{ type: Input }],
        className: [{ type: HostBinding, args: ['class',] }],
        id: [{ type: HostBinding, args: ['id',] }],
        _checked: [{ type: HostBinding, args: ['class.cbp-toggle-switch-checked',] }],
        required: [{ type: Input }],
        change: [{ type: Output }],
        checked: [{ type: Input }]
    };
    return CBPToggleSwitchComponent;
}(_CBPToggleSwitchMixinBase));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPButtonsModule = /** @class */ (function () {
    function CBPButtonsModule() {
    }
    CBPButtonsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, FormsModule
                    ],
                    exports: [CBPToggleSwitchComponent],
                    declarations: [CBPToggleSwitchComponent]
                },] }
    ];
    return CBPButtonsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Models list of applications, recents, favorites, currentApp etc so that subscribers can get everything in one subscription.
 */
var  /**
 * Models list of applications, recents, favorites, currentApp etc so that subscribers can get everything in one subscription.
 */
CBPApplicationsData = /** @class */ (function () {
    function CBPApplicationsData() {
        this.list = [];
        this.recents = [];
        this.favorites = [];
        this.currentApp = (/** @type {?} */ ({}));
    }
    return CBPApplicationsData;
}());
/**
 * @abstract
 */
var  /**
 * @abstract
 */
CBPApplicationsService = /** @class */ (function () {
    function CBPApplicationsService() {
        this.currentApp = new ReplaySubject(1);
    }
    /**
     * Provides consumers to subscribe to current application so that they can do various things e.g. setting version etc.
     * @returns Observable<CBPApplication>
     */
    /**
     * Provides consumers to subscribe to current application so that they can do various things e.g. setting version etc.
     * @return {?} Observable<CBPApplication>
     */
    CBPApplicationsService.prototype.getCurrentApp = /**
     * Provides consumers to subscribe to current application so that they can do various things e.g. setting version etc.
     * @return {?} Observable<CBPApplication>
     */
    function () {
        return this.currentApp;
    };
    /**
     * @return {?}
     */
    CBPApplicationsService.prototype.getApplicationsDirectoryUrl = /**
     * @return {?}
     */
    function () {
        return window.location.origin;
    };
    return CBPApplicationsService;
}());
/** @type {?} */
var CBP_APPLICATIONS_SERVICE = new InjectionToken('cbp-applications-service');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var CBP_HEADER_STATE = new InjectionToken('cbp-toolbar-state-service');
/** @type {?} */
var APP_HEADER_STATE = new InjectionToken('app-toolbar-state-service');
/**
 * Holds a single cbp-notification state as well as serves as a observable.
 */
var  /**
 * Holds a single cbp-notification state as well as serves as a observable.
 */
CBPToolbarState = /** @class */ (function () {
    function CBPToolbarState() {
        this.hasToolbarMenu = new BehaviorSubject(false);
        this.toolbarIsExpanded = new BehaviorSubject(false);
        this.scrollState = new BehaviorSubject('initial');
        this._scrollShrinkSuspended = false;
    }
    Object.defineProperty(CBPToolbarState.prototype, "scrollShrinkSuspended", {
        get: /**
         * @return {?}
         */
        function () {
            return this._scrollShrinkSuspended;
        },
        set: /**
         * @param {?} suspended
         * @return {?}
         */
        function (suspended) {
            this._scrollShrinkSuspended = suspended;
        },
        enumerable: true,
        configurable: true
    });
    return CBPToolbarState;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPApplicationsMenuComponent = /** @class */ (function () {
    function CBPApplicationsMenuComponent(_cdr, applicationsService, toolbarState) {
        this._cdr = _cdr;
        this.applicationsService = applicationsService;
        this.toolbarState = toolbarState;
        this.menuDataLoaded = false;
        this.applicationsDataLoading = true;
        this.isApplicationsExpanded = false;
        this.subscriptions = new Subscription();
    }
    Object.defineProperty(CBPApplicationsMenuComponent.prototype, "toolbarIsExpanded", {
        get: /**
         * @return {?}
         */
        function () {
            return this.toolbarState.toolbarIsExpanded.getValue();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.subscriptions.add(this.toolbarState.hasToolbarMenu.subscribe((/**
         * @return {?}
         */
        function () {
            if (_this.cbpMenuTrigger && _this.cbpMenuTrigger.menu) {
                _this.isApplicationsExpanded = false;
                _this.cbpMenuTrigger.closeMenu();
                _this._cdr.markForCheck();
            }
        })));
        if (this.applicationsService) {
            this.subscriptions.add(this.applicationsService.getApplicationsData()
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                _this.applicationsData = data;
                if (data) {
                    _this.menuDataLoaded = true;
                    _this.applicationsDataLoading = false;
                }
                _this._cdr.markForCheck();
            }), (/**
             * @param {?} err
             * @return {?}
             */
            function (err) {
                _this.error = err;
                _this.applicationsDataLoading = false;
                console.log(err);
                _this._cdr.markForCheck();
            })));
        }
        this.subscriptions.add(this.toolbarState.scrollState.subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value === 'up') {
                _this._cdr.markForCheck();
                _this.cbpMenuTrigger.closeMenu();
            }
        })));
    };
    /**
     * @param {?} app
     * @param {?} $event
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.removeFromRecent = /**
     * @param {?} app
     * @param {?} $event
     * @return {?}
     */
    function (app, $event) {
        this.applicationsService.removeRecentApplication(app);
        $event.stopPropagation();
    };
    /**
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.subscriptions.unsubscribe();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.reloadApplicationsData = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        var _this = this;
        this.applicationsDataLoading = true;
        this._cdr.markForCheck();
        this.applicationsService.refresh().pipe(first()).subscribe((/**
         * @return {?}
         */
        function () {
            _this.applicationsDataLoading = false;
            console.log('this.applicationsDataLoading', _this.applicationsDataLoading);
            _this._cdr.markForCheck();
        }));
        $event.stopPropagation();
    };
    /**
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.getApplicationsDirectoryUrl = /**
     * @return {?}
     */
    function () {
        return this.applicationsService.getApplicationsDirectoryUrl();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.toggleApplicationsMenu = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        if (this.toolbarState.toolbarIsExpanded.getValue()) {
            this.isApplicationsExpanded = !this.isApplicationsExpanded;
            $event.stopPropagation();
        }
        else {
            if (this.cbpMenuTrigger) {
                this.cbpMenuTrigger.toggleMenu();
            }
        }
    };
    // TODO find a way to share this
    // TODO find a way to share this
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPApplicationsMenuComponent.prototype.stopPropogation = 
    // TODO find a way to share this
    /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        $event.stopPropagation();
    };
    CBPApplicationsMenuComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-apps-menu',
                    template: "<div class=\"cbp-applications-navitem\">\r\n  <ng-template [ngTemplateOutlet]=\"application\"></ng-template>\r\n</div>\r\n\r\n<div class=\"applications-expansion-panel inverse\" *ngIf=\"isApplicationsExpanded  && menuDataLoaded\">\r\n  <ng-template [ngTemplateOutlet]=\"applicationsPanel\"></ng-template>\r\n</div>\r\n\r\n<mat-menu #cbpMenu=\"matMenu\" yPosition=\"above\" xPosition=\"after\" [overlapTrigger]=\"false\"\r\n          class=\"cbp-menu-with-category applications-expansion-panel\">\r\n  <ng-template [ngTemplateOutlet]=\"applicationsPanel\"></ng-template>\r\n</mat-menu>\r\n\r\n\r\n<ng-template #applicationsPanel>\r\n  <ng-container *ngIf=\"applicationsData\">\r\n\r\n    <div class=\"cbp-menu-item-category\" *ngIf=\"applicationsData.recents?.length > 0\">Recent Apps</div>\r\n    <div class=\"mat-menu-item\" *ngFor=\"let app of applicationsData.recents\">\r\n      <mat-icon color=\"default\" class=\"cbp-applications-remove-icon\" fontSet=\"fontawesome\" fontIcon=\"fa-times\"\r\n                (click)=\"removeFromRecent(app, $event)\" fxFlexAlign=\"center\"></mat-icon>\r\n      <a class=\"cbp-applications-link\" title=\"{{app.description}}\" href=\"{{app.href}}\" fxFlex=\"auto\">\r\n        {{ app.name }}\r\n      </a>\r\n    </div>\r\n\r\n    <mat-divider *ngIf=\"applicationsData.recents?.length > 0\"></mat-divider>\r\n\r\n    <div class=\"cbp-menu-item-category\" *ngIf=\"applicationsData.favorites?.length > 0\">Favorite Apps</div>\r\n    <div class=\"mat-menu-item\" *ngFor=\"let app of applicationsData.favorites\">\r\n      <a class=\"cbp-applications-link\" title=\"{{app.description}}\" href=\"{{app.href}}\" fxFlex=\"auto\">\r\n        {{ app.name }}\r\n      </a>\r\n    </div>\r\n\r\n\r\n    <mat-divider class=\"mat-divider\" *ngIf=\"applicationsData.favorites?.length > 0\"></mat-divider>\r\n\r\n    <cbp-applications-search></cbp-applications-search>\r\n\r\n    <a class=\"mat-menu-item cbp-applications-see-all\" href=\"{{ getApplicationsDirectoryUrl() }}\">\r\n      <div>See All Available Apps...</div>\r\n    </a>\r\n    <a class=\"mat-menu-item cbp-applications-refresh\" (click)=\"reloadApplicationsData($event)\">\r\n      <div>Refresh</div>\r\n    </a>\r\n    <div class=\"cbp-applications-last-updated\" (click)=\"stopPropogation($event)\">\r\n      <small>Updated {{ applicationsData.lastRetrieved | datetime }}</small>\r\n    </div>\r\n  </ng-container>\r\n\r\n</ng-template>\r\n<ng-template #application>\r\n  <div class=\"cbp-current-application\" fxShow=\"false\" fxShow.gt-xs fxShow.lt-sm fxLayout=\"column\"\r\n       fxLayoutAlign=\"center start\">\r\n    <div *ngIf=\"applicationsDataLoading\" class=\"cbp-menu-loading\" style=\"color: white\">\r\n      <cbp-loading></cbp-loading>\r\n    </div>\r\n    <div role=\"button\" *ngIf=\"menuDataLoaded && applicationsData.currentApp && !applicationsDataLoading\"\r\n         class=\"cbp-current-application-name-container\" (click)=\"toggleApplicationsMenu($event)\">\r\n      <span class=\"cbp-current-application-name\">{{ applicationsData.currentApp.name }}</span><span\r\n      *ngIf=\"applicationsData.currentApp.version\"> - {{ applicationsData.currentApp.version }}</span>\r\n      <mat-icon *ngIf=\"applicationsData.lastRetrieved\" fontSet=\"fontawesome\" fontIcon=\"fa-caret-down\"></mat-icon>\r\n    </div>\r\n  </div>\r\n</ng-template>\r\n\r\n<div [matMenuTriggerFor]=\"cbpMenu\"></div>\r\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    entryComponents: [],
                    styles: [".cbp-current-application{height:50px}.cbp-current-application-name{line-height:1em}.cbp-current-application-name .mat-icon{margin-left:5px;height:14px}.cbp-current-application-version{line-height:1.42857;font-size:12px;font-style:italic}.mat-menu-item .cbp-applications-remove-icon .mat-icon{vertical-align:inherit;margin-right:8px}.mat-menu-item .cbp-applications-remove-icon .mat-icon:focus,.mat-menu-item .cbp-applications-remove-icon .mat-icon:hover{color:#222;cursor:pointer}.cbp-applications-refresh{cursor:pointer}.cbp-applications-last-updated{float:left;padding:0 16px 6px;color:#aaa;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.applications-expansion-panel.inverse .cbp-applications-link,.applications-expansion-panel.inverse .cbp-applications-refresh,.inverse .applications-expansion-panel .cbp-applications-remove-icon .mat-icon{color:#fff!important}.cbp-applications-remove-icon .mat-icon{height:inherit!important;vertical-align:inherit;margin-right:0}.applications-expansion-panel .mat-menu-item .mat-icon{margin-right:16px}.applications-expansion-panel{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;overflow-x:hidden}.cbp-menu-item-category{margin-left:10px;pointer-events:none;padding:5px}.mat-button{font-weight:400!important}.mat-button :hover{background-color:#003e65}.mat-menu-item .mat-icon{margin-right:0}"]
                }] }
    ];
    /** @nocollapse */
    CBPApplicationsMenuComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: CBPApplicationsService, decorators: [{ type: Inject, args: [CBP_APPLICATIONS_SERVICE,] }] },
        { type: CBPToolbarState, decorators: [{ type: Inject, args: [CBP_HEADER_STATE,] }] }
    ]; };
    CBPApplicationsMenuComponent.propDecorators = {
        cbpMenuTrigger: [{ type: ViewChild, args: [MatMenuTrigger,] }]
    };
    return CBPApplicationsMenuComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPLoadingComponent = /** @class */ (function () {
    function CBPLoadingComponent() {
        this.loadingText = 'Loading ...';
    }
    /**
     * @return {?}
     */
    CBPLoadingComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    CBPLoadingComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-loading',
                    template: "<i class=\"fa fa-spinner fa-spin\"></i><span>&nbsp;{{ loadingText }}</span>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    CBPLoadingComponent.ctorParameters = function () { return []; };
    CBPLoadingComponent.propDecorators = {
        loadingText: [{ type: Input }]
    };
    return CBPLoadingComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPProgressModule = /** @class */ (function () {
    function CBPProgressModule() {
    }
    CBPProgressModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    exports: [CBPLoadingComponent],
                    declarations: [CBPLoadingComponent]
                },] }
    ];
    return CBPProgressModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var DATE_FORMAT_DayOfWeek_ShortDate_Time = {
    weekday: 'short',
    month: 'short',
    day: 'numeric',
    hour: 'numeric',
    minute: '2-digit'
};
var CBPDatetimePipe = /** @class */ (function () {
    function CBPDatetimePipe() {
    }
    /**
     * @param {?} value
     * @return {?}
     */
    CBPDatetimePipe.prototype.transform = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return new Intl.DateTimeFormat('en-US', DATE_FORMAT_DayOfWeek_ShortDate_Time).format(value);
    };
    CBPDatetimePipe.decorators = [
        { type: Pipe, args: [{
                    name: 'datetime'
                },] }
    ];
    return CBPDatetimePipe;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPPipesModule = /** @class */ (function () {
    function CBPPipesModule() {
    }
    CBPPipesModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    exports: [CBPDatetimePipe],
                    declarations: [CBPDatetimePipe]
                },] }
    ];
    return CBPPipesModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPApplicationsSearchComponent = /** @class */ (function () {
    function CBPApplicationsSearchComponent(applicationsService, _cdr) {
        this.applicationsService = applicationsService;
        this._cdr = _cdr;
        this.searchTokenControl = new FormControl();
        this.searchResults = [];
    }
    /**
     * @return {?}
     */
    CBPApplicationsSearchComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.searchResultsApplications = this.searchTokenControl.valueChanges.pipe(startWith(null), map((/**
         * @param {?} token
         * @return {?}
         */
        function (token) {
            _this._cdr.markForCheck();
            return _this._search(token);
        })));
    };
    /**
     * @private
     * @param {?} token
     * @return {?}
     */
    CBPApplicationsSearchComponent.prototype._search = /**
     * @private
     * @param {?} token
     * @return {?}
     */
    function (token) {
        if (token) {
            /** @type {?} */
            var allResults = this.applicationsService.search(token);
            if (allResults) {
                this.searchResults = allResults.filter((/**
                 * @param {?} val
                 * @param {?} index
                 * @return {?}
                 */
                function (val, index) {
                    if (val) {
                        return index < 5;
                    }
                }));
            }
        }
        else {
            this.searchResults.length = 0;
        }
        return this.searchResults;
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPApplicationsSearchComponent.prototype.stopPropogation = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        $event.stopPropagation();
    };
    CBPApplicationsSearchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-applications-search',
                    template: "<form class=\"mat-menu-item cbp-app-search\">\r\n  <mat-form-field (click)=\"stopPropogation($event)\" floatLabel=\"never\" color=\"default\">\r\n    <input type=\"text\" matInput aria-label=\"Search App\" [formControl]=\"searchTokenControl\" name=\"searchToken\"\r\n           placeholder=\"Search ...\"\r\n           class=\"cbp-applications-search-input\"/>\r\n  </mat-form-field>\r\n</form>\r\n<ng-container *ngIf=\"searchResults\">\r\n  <div class=\"mat-menu-item cbp-app-search-results\" *ngFor=\"let app of searchResultsApplications | async\">\r\n    <a class=\"cbp-applications-link\" title=\"{{app.description}}\" href=\"{{app.href}}\" fxFlex=\"auto\">\r\n      {{ app.name }}\r\n    </a>\r\n  </div>\r\n  <mat-divider *ngIf=\"searchResults && searchResults.length > 0\"></mat-divider>\r\n</ng-container>\r\n",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".mat-menu-item .cbp-applications-link{text-decoration:none;color:#333;overflow:inherit;text-overflow:inherit}.mat-menu-item .cbp-applications-link:focus,.mat-menu-item .cbp-applications-link:hover{text-decoration:underline}.inverse .mat-menu-item .cbp-applications-link{color:#fff}.cbp-app-search{padding:0}.cbp-app-search .mat-form-field{display:block}.cbp-app-search .cbp-applications-search-input,.cbp-app-search .mat-form-field-label{padding-left:16px}.cbp-app-search-results.mat-menu-item{cursor:inherit;height:32px;line-height:32px}"]
                }] }
    ];
    /** @nocollapse */
    CBPApplicationsSearchComponent.ctorParameters = function () { return [
        { type: CBPApplicationsService, decorators: [{ type: Inject, args: [CBP_APPLICATIONS_SERVICE,] }] },
        { type: ChangeDetectorRef }
    ]; };
    CBPApplicationsSearchComponent.propDecorators = {
        isApplicationsExpanded: [{ type: Input }]
    };
    return CBPApplicationsSearchComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPApplicationsModule = /** @class */ (function () {
    function CBPApplicationsModule() {
    }
    CBPApplicationsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, MatMenuModule, MatIconModule, FlexLayoutModule, FormsModule, ReactiveFormsModule, MatInputModule, MatFormFieldModule,
                        MatDividerModule, CBPProgressModule, CBPPipesModule,
                        MatButtonModule
                    ],
                    declarations: [CBPApplicationsMenuComponent, CBPApplicationsSearchComponent],
                    exports: [CBPApplicationsMenuComponent, CBPApplicationsSearchComponent]
                },] }
    ];
    return CBPApplicationsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPRootComponent = /** @class */ (function () {
    function CBPRootComponent() {
    }
    /**
     * @return {?}
     */
    CBPRootComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    CBPRootComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-root',
                    template: "<!-- Generated from ngx-cbp-theme -->\r\n<ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    styles: [".cbp-theme .cbp-app-header.mat-toolbar,.cbp-theme .cbp-header.mat-toolbar{padding:0;min-height:inherit}.cbp-theme .mat-toolbar{font-weight:inherit!important;min-height:inherit}.cbp-theme .mat-tab-label,.cbp-theme .mat-tab-link{font-size:15px!important;opacity:inherit!important}cbp-root{display:flex;flex-direction:column;height:100vh;place-content:stretch flex-start;align-items:stretch;max-width:100%}"]
                }] }
    ];
    /** @nocollapse */
    CBPRootComponent.ctorParameters = function () { return []; };
    CBPRootComponent.propDecorators = {
        ngOnInit: [{ type: HostBinding, args: ['class.cbp-theme',] }]
    };
    return CBPRootComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * CBPUser class can be extended by the library users to include additional attributes.
 */
var  /**
 * CBPUser class can be extended by the library users to include additional attributes.
 */
CBPUser = /** @class */ (function () {
    function CBPUser() {
    }
    return CBPUser;
}());
/**
 * The implementation is beyond the scope of this library since it involves fetching the authenticated
 *  user who is accessing your application.
 * This service must be implemented by library users or by another CF components.
 * @abstract
 */
var  /**
 * The implementation is beyond the scope of this library since it involves fetching the authenticated
 *  user who is accessing your application.
 * This service must be implemented by library users or by another CF components.
 * @abstract
 */
CBPUserService = /** @class */ (function () {
    function CBPUserService() {
        this._loginInProgress = false;
    }
    Object.defineProperty(CBPUserService.prototype, "loginInProgress", {
        get: /**
         * @return {?}
         */
        function () {
            return this._loginInProgress;
        },
        set: /**
         * @param {?} loginInProgress
         * @return {?}
         */
        function (loginInProgress) {
            this._loginInProgress = loginInProgress;
        },
        enumerable: true,
        configurable: true
    });
    return CBPUserService;
}());
/** @type {?} */
var CBP_USER_SERVICE = new InjectionToken('cbp-user-service');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPUserMenuComponent = /** @class */ (function () {
    function CBPUserMenuComponent(userService, toolbarState) {
        this.userService = userService;
        this.toolbarState = toolbarState;
        this.userMenuExpanded = false;
        this.isLoggedIn = false;
        this.userDataLoaded = false;
        this.subscriptions = new Subscription();
    }
    Object.defineProperty(CBPUserMenuComponent.prototype, "toolbarIsExpanded", {
        get: /**
         * @return {?}
         */
        function () {
            return this.toolbarState.toolbarIsExpanded.getValue();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CBPUserMenuComponent.prototype, "loginProgress", {
        get: /**
         * @return {?}
         */
        function () {
            return this.userService.loginInProgress;
        },
        set: /**
         * @param {?} progress
         * @return {?}
         */
        function (progress) {
            this.userService.loginInProgress = progress;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CBPUserMenuComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.subscriptions.add(this.toolbarState.hasToolbarMenu.subscribe((/**
         * @return {?}
         */
        function () {
            if (_this.userMenuTrigger && _this.userMenuTrigger.menu) {
                _this.userMenuExpanded = false;
                _this.userMenuTrigger.closeMenu();
            }
        })));
        this.subscriptions.add(this.userService.getUser().subscribe({
            next: (/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                if (data) {
                    _this.user = data;
                    _this.userDataLoaded = true;
                    _this.loginProgress = false;
                    _this.isLoggedIn = true;
                }
                else {
                    _this.loginProgress = false;
                    _this.isLoggedIn = false;
                    _this.user = data;
                    _this.userDataLoaded = false;
                }
            }),
            error: (/**
             * @param {?} err
             * @return {?}
             */
            function (err) {
                _this.loginProgress = false;
                _this.isLoggedIn = false;
                _this.error = err;
                _this.userDataLoaded = false;
            })
        }));
        this.subscriptions.add(this.toolbarState.scrollState.subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value === 'up') {
                _this.userMenuTrigger.closeMenu();
            }
        })));
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPUserMenuComponent.prototype.login = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        this.loginProgress = true;
        this.isLoggedIn = false;
        this.userService.login();
    };
    /**
     * @return {?}
     */
    CBPUserMenuComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.subscriptions.unsubscribe();
        this.user = undefined;
        this.userDataLoaded = false;
    };
    /**
     * @return {?}
     */
    CBPUserMenuComponent.prototype.logout = /**
     * @return {?}
     */
    function () {
        this.isLoggedIn = false;
        this.userService.logout();
        this.userMenuExpanded = false;
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPUserMenuComponent.prototype.toggleMenu = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        if (!this.isLoggedIn || !this.userDataLoaded) {
            return;
        }
        if (this.toolbarState.toolbarIsExpanded.getValue()) {
            this.userMenuExpanded = !this.userMenuExpanded;
            $event.stopPropagation();
        }
        else {
            if (this.userMenuTrigger) {
                this.userMenuTrigger.toggleMenu();
            }
        }
    };
    CBPUserMenuComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-user-menu, [cbp-user-menu], .cbp-user-menu',
                    template: "<div class=\"cbp-user-navitem\">\r\n  <ng-template [ngTemplateOutlet]=\"userView\"></ng-template>\r\n</div>\r\n\r\n<ng-template #userView>\r\n  <div role=\"button\" *ngIf=\"!isLoggedIn && !loginProgress\" (click)=\"login($event)\">\r\n    <mat-icon fontSet=\"fontawesome\" fontIcon=\"fa-sign-in\"></mat-icon>\r\n    <span fxShow=\"false\" fxShow.gt-sm fxShow.lt-sm>Login</span>\r\n  </div>\r\n  <div class=\"cbp-user-login-in-progress\" *ngIf=\"!isLoggedIn && loginProgress\">\r\n    <cbp-loading></cbp-loading>\r\n  </div>\r\n\r\n  <div role=\"button\" *ngIf=\"isLoggedIn && userDataLoaded\" (click)=\"toggleMenu($event)\">\r\n    <mat-icon fontSet=\"fontawesome\" fontIcon=\"fa-user\"></mat-icon>\r\n    <span fxShow=\"false\" fxShow.gt-sm fxShow.lt-sm>{{ user.firstName }} {{ user.lastName }}</span>\r\n    <mat-icon fontSet=\"fontawesome\" fontIcon=\"fa-caret-down\"></mat-icon>\r\n  </div>\r\n</ng-template>\r\n\r\n<mat-menu #userMenu=\"matMenu\" yPosition=\"above\" xPosition=\"before\" [overlapTrigger]=\"false\">\r\n  <ng-template [ngTemplateOutlet]=\"userMenuPanel\"></ng-template>\r\n</mat-menu>\r\n\r\n<div class=\"cbp-user-panel-expanded\" *ngIf=\"toolbarIsExpanded && userDataLoaded && userMenuExpanded\">\r\n  <ng-template [ngTemplateOutlet]=\"userMenuPanel\"></ng-template>\r\n</div>\r\n\r\n\r\n<ng-template #userMenuPanel>\r\n  <ng-content select=\"div[cbp-user-menu-item]\"></ng-content>\r\n  <div class=\"mat-menu-item\" (click)=\"logout()\"><i class=\"fa fa-sign-out\"></i>Logout</div>\r\n</ng-template>\r\n\r\n<div [matMenuTriggerFor]=\"userMenu\"></div>\r\n",
                    encapsulation: ViewEncapsulation.None,
                    styles: [":host{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.cbp-user-panel-expanded .mat-menu-item{color:#fff!important}.cbp-user-login-in-progress,.cbp-user-not-logged-in{display:flex;align-content:center;align-items:center;vertical-align:middle;height:48px}"]
                }] }
    ];
    /** @nocollapse */
    CBPUserMenuComponent.ctorParameters = function () { return [
        { type: CBPUserService, decorators: [{ type: Inject, args: [CBP_USER_SERVICE,] }] },
        { type: CBPToolbarState, decorators: [{ type: Inject, args: [CBP_HEADER_STATE,] }] }
    ]; };
    CBPUserMenuComponent.propDecorators = {
        userMenuTrigger: [{ type: ViewChild, args: [MatMenuTrigger,] }]
    };
    return CBPUserMenuComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Feedback service implementation is beyond the scope of this library.
 * We recommend developing an independent module that implements the following service.
 * @abstract
 */
var  /**
 * Feedback service implementation is beyond the scope of this library.
 * We recommend developing an independent module that implements the following service.
 * @abstract
 */
CBPFeedbackService = /** @class */ (function () {
    function CBPFeedbackService() {
    }
    return CBPFeedbackService;
}());
/** @type {?} */
var CBP_FEEDBACK_SERVICE = new InjectionToken('cbp-feedback-service');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPFeedbackLinkComponent = /** @class */ (function () {
    function CBPFeedbackLinkComponent(feedbackService) {
        this.feedbackService = feedbackService;
        if (this.feedbackService) {
            this.feedbackService.onFeedbackClose(this.feedbackDone);
        }
    }
    /**
     * @return {?}
     */
    CBPFeedbackLinkComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    CBPFeedbackLinkComponent.prototype.handleFeedback = /**
     * @return {?}
     */
    function () {
        if (this.feedbackService) {
            this.feedbackService.handleFeedback();
        }
        else {
            console.log('Provide CBP_FEEDBACK_SERVICE to execute feedback service');
        }
    };
    /**
     * @private
     * @return {?}
     */
    CBPFeedbackLinkComponent.prototype.feedbackDone = /**
     * @private
     * @return {?}
     */
    function () {
    };
    CBPFeedbackLinkComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-feedback-link',
                    template: "<div class=\"cbp-feedback-navitem\">\r\n  <div role=\"button\" (click)=\"handleFeedback()\">\r\n    <mat-icon fontSet=\"fontawesome\" fontIcon=\"fa-comment\"></mat-icon>\r\n    <span fxShow=\"false\" fxShow.gt-sm fxShow.lt-sm style=\"display: inline-block\">Feedback</span>\r\n  </div>\r\n</div>\r\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    CBPFeedbackLinkComponent.ctorParameters = function () { return [
        { type: CBPFeedbackService, decorators: [{ type: Optional }, { type: Inject, args: [CBP_FEEDBACK_SERVICE,] }] }
    ]; };
    return CBPFeedbackLinkComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPHeaderComponent = /** @class */ (function () {
    function CBPHeaderComponent(state$$1, applicationsService) {
        this.applicationsService = applicationsService;
        this.toolbarState = state$$1;
    }
    /**
     * @param {?} comp
     * @return {?}
     */
    CBPHeaderComponent.prototype.isProvided = /**
     * @param {?} comp
     * @return {?}
     */
    function (comp) {
        return comp ? true : false;
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPHeaderComponent.prototype.navigateToAppsDir = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        if (this.applicationsService) {
            /** @type {?} */
            var appsDirUrl = this.applicationsService.getApplicationsDirectoryUrl();
            if (appsDirUrl) {
                window.location.href = appsDirUrl;
            }
        }
    };
    CBPHeaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-header',
                    template: "<cbp-toolbar [position]=\"0\" [toolbarState]=\"toolbarState\" #cbpToolbar>\r\n\r\n  <div class=\"cbp-brand-nav cbp-toolbar-title\" fxFlexAlign=\"stretch\" fxLayout=\"row\" (click)=\"navigateToAppsDir($event)\">\r\n    <ng-template [ngTemplateOutlet]=\"cbpBrand\"></ng-template>\r\n  </div>\r\n\r\n\r\n  <div class=\"cbp-toolbar-main-nav\" *ngIf=\"!cbpAppsMenuExclude && !isProvided(cbpAppsMenu)\">\r\n    <cbp-apps-menu></cbp-apps-menu>\r\n  </div>\r\n  <!-- potential downstream customization of apps-menu -->\r\n  <div class=\"cbp-toolbar-main-nav\" *ngIf=\"!cbpAppsMenuExclude && isProvided(cbpAppsMenu)\">\r\n    <ng-content select=\"cbp-applications-menu\"></ng-content>\r\n  </div>\r\n\r\n  <div class=\"cbp-toolbar-right-nav\" fxFlexAlign.gt-xs=\"end\" fxLayout.gt-xs=\"row\" fxLayout.lt-sm=\"column\">\r\n\r\n    <div fxFlex=\"auto\" *ngIf=\"!cbpFeedbackLinkExclude && !isProvided(cbpFeedbackLink)\">\r\n      <cbp-feedback-link></cbp-feedback-link>\r\n    </div>\r\n    <!-- potential downstream customization of feedback -->\r\n    <div fxFlex=\"auto\" *ngIf=\"!cbpFeedbackLinkExclude && isProvided(cbpFeedbackLink)\">\r\n      <ng-content select=\"cbp-feedback-link\"></ng-content>\r\n    </div>\r\n\r\n    <div fxFlex=\"auto\" *ngIf=\"!cbpUserMenuExclude && !isProvided(cbpUserMenu)\">\r\n      <cbp-user-menu></cbp-user-menu>\r\n    </div>\r\n    <!-- downstream customization of user-menu e.g. additional cbp-user-menu-item -->\r\n    <div fxFlex=\"auto\" *ngIf=\"!cbpUserMenuExclude && isProvided(cbpUserMenu)\">\r\n      <ng-content select=\"cbp-user-menu\"></ng-content>\r\n    </div>\r\n\r\n  </div>\r\n</cbp-toolbar>\r\n\r\n<mat-list style=\"display: none\"></mat-list>\r\n\r\n<ng-template #cbpBrand>\r\n  <div fxFlexAlign=\"center\" fxLayout=\"column\" fxLayoutAlign=\"start start\">\r\n    <h1 class=\"cbp-brand\" fxShow=\"false\" fxShow.gt-sm>U.S. Customs & Border Protection</h1>\r\n    <div class=\"cbp-brand-short\" fxShow=\"false\" fxShow.lt-md>U.S. CBP</div>\r\n    <div class=\"dhs-brand\" fxShow=\"false\" fxShow.gt-sm>U.S. Department of Homeland Security</div>\r\n  </div>\r\n</ng-template>\r\n",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".cbp-applications-navitem,.cbp-feedback-navitem,.cbp-navbar-item,.cbp-navbar-item-default,.cbp-toolbar-expansion,.cbp-user-navitem{font-size:15px;display:flex;align-content:center;align-items:center;vertical-align:middle;height:50px;padding:0 16px}.cbp-applications-navitem,.cbp-feedback-navitem,.cbp-navbar-item,.cbp-toolbar-expansion,.cbp-user-navitem{cursor:pointer}.cbp-applications-navitem:focus,.cbp-applications-navitem:hover,.cbp-feedback-navitem:focus,.cbp-feedback-navitem:hover,.cbp-navbar-item:focus,.cbp-navbar-item:hover,.cbp-toolbar-expansion:focus,.cbp-toolbar-expansion:hover,.cbp-user-navitem:focus,.cbp-user-navitem:hover{outline:dotted thin;outline-offset:-2px;text-decoration:none}.cbp-toolbar-expansion-container .cbp-toolbar-expansion:hover,.cbp-toolbar-expansion-container:hover{outline:0}.cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon{border:1px solid #ddd;position:relative;margin:0;cursor:inherit;padding:9px 10px;border-radius:2px;min-width:inherit;background-color:#f8f8f8}.cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:hover{background-color:#ddd}.cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:focus{border-color:#ddd;outline:#fff dotted 1px!important}.icon-bar+.icon-bar{margin-top:4px}.icon-bar{background-color:#888;display:block;width:22px;height:2px;border-radius:1px}cbp-header{z-index:1010}cbp-header cbp-toolbar .cbp-toolbar-row{height:50px;background-color:#003e65;color:#fff;border-bottom-color:#003456;position:fixed;right:0;left:0}cbp-header .cbp-toolbar-expansion-panel{top:50px!important}cbp-header .cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon{border:1px solid #002e4b;background-color:#003e65}cbp-header .cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:hover{background-color:#333}cbp-header .cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:focus{border-color:#333;outline:#1461ab dotted 1px!important}cbp-header .icon-bar{background-color:#fff}cbp-header .mat-toolbar h1{font-weight:inherit}.cbp-brand-nav{font-size:19px;transition:color .2s ease-in-out;height:50px;cursor:pointer;padding:0 70px 0 15px}.cbp-brand-nav:focus,.cbp-brand-nav:hover{outline:dotted thin;outline-offset:-2px;text-decoration:none}.cbp-brand-nav .cbp-brand{font-size:19px;line-height:21px}.cbp-brand-nav .dhs-brand{line-height:14px;margin:0;font-size:12px;font-style:italic}.cbp-theme cbp-toolbar .mat-button{border:inherit;font-size:15px;height:48px}.cbp-theme cbp-toolbar .mat-button .mat-button-wrapper{font-weight:400}.cbp-theme cbp-toolbar .mat-button .mat-icon{height:inherit;width:inherit;padding:2px}.cbp-theme cbp-toolbar .mat-icon{width:inherit;padding:0 4px}"]
                }] }
    ];
    /** @nocollapse */
    CBPHeaderComponent.ctorParameters = function () { return [
        { type: CBPToolbarState, decorators: [{ type: Inject, args: [CBP_HEADER_STATE,] }] },
        { type: CBPApplicationsService, decorators: [{ type: Inject, args: [CBP_APPLICATIONS_SERVICE,] }] }
    ]; };
    CBPHeaderComponent.propDecorators = {
        cbpAppsMenuExclude: [{ type: Input }],
        cbpFeedbackLinkExclude: [{ type: Input }],
        cbpUserMenuExclude: [{ type: Input }],
        cbpAppsMenu: [{ type: ContentChild, args: [CBPApplicationsMenuComponent,] }],
        cbpFeedbackLink: [{ type: ContentChild, args: [CBPFeedbackLinkComponent,] }],
        cbpUserMenu: [{ type: ContentChild, args: [CBPUserMenuComponent,] }]
    };
    return CBPHeaderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPUserModule = /** @class */ (function () {
    function CBPUserModule() {
    }
    CBPUserModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, MatListModule, MatMenuModule, FlexLayoutModule, MatIconModule, MatButtonModule, CBPProgressModule
                    ],
                    exports: [CBPUserMenuComponent, MatMenuModule],
                    declarations: [CBPUserMenuComponent]
                },] }
    ];
    return CBPUserModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var HEADER_SHRINK_TRANSITION = '250ms cubic-bezier(0.4,0.0,0.2,1)';
var CBPScrollShrinkAnimator = /** @class */ (function () {
    function CBPScrollShrinkAnimator() {
    }
    /**
     * @param {?} triggerName
     * @param {?} initialTop
     * @param {?} upTop
     * @return {?}
     */
    CBPScrollShrinkAnimator.createScrollShrinkTrigger = /**
     * @param {?} triggerName
     * @param {?} initialTop
     * @param {?} upTop
     * @return {?}
     */
    function (triggerName, initialTop, upTop) {
        return trigger(triggerName, [
            state('initial', style({ top: initialTop })),
            state('up', style({ top: upTop })),
            transition('initial => up, up => initial', animate(HEADER_SHRINK_TRANSITION))
        ]);
    };
    return CBPScrollShrinkAnimator;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPToolbarComponent = /** @class */ (function () {
    function CBPToolbarComponent(mediaObserver, _cdr) {
        this.mediaObserver = mediaObserver;
        this._cdr = _cdr;
        this._subscription = new Subscription();
        this.role = 'toolbar';
        this.hideToolbarItem = new EventEmitter();
    }
    Object.defineProperty(CBPToolbarComponent.prototype, "isToolbarExpanded", {
        get: /**
         * @return {?}
         */
        function () {
            return this.toolbarState.toolbarIsExpanded.getValue();
        },
        set: /**
         * @param {?} expanded
         * @return {?}
         */
        function (expanded) {
            this.toolbarState.toolbarIsExpanded.next(expanded);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CBPToolbarComponent.prototype, "hasToolbarMenu", {
        set: /**
         * @param {?} has
         * @return {?}
         */
        function (has) {
            this.toolbarState.hasToolbarMenu.next(has);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CBPToolbarComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.cbpToolbarScrollState = 'initial';
        this._subscription.add(this.mediaObserver.media$.subscribe((/**
         * @param {?} change
         * @return {?}
         */
        function (change) {
            if (change.mqAlias !== 'xs') {
                _this.isToolbarExpanded = false;
                _this.hasToolbarMenu = false;
            }
            else {
                _this.hasToolbarMenu = true;
            }
            _this._cdr.markForCheck();
        })));
    };
    /**
     * @return {?}
     */
    CBPToolbarComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._subscription.unsubscribe();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    CBPToolbarComponent.prototype.scrolled = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        if (!this.toolbarState.scrollShrinkSuspended) {
            this.cbpToolbarScrollState = window.pageYOffset <= 50 ? 'initial' : 'up';
            this.toolbarState.scrollState.next(this.cbpToolbarScrollState);
            this.isToolbarExpanded = false;
        }
    };
    /**
     * @return {?}
     */
    CBPToolbarComponent.prototype.getToolbarExpansionPanelTop = /**
     * @return {?}
     */
    function () {
        return this.toolbarState.scrollState.getValue() === 'initial' ? '98px' : '50px';
    };
    CBPToolbarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-toolbar',
                    template: "<div class=\"cbp-toolbar-row mat-toolbar mat-toolbar-row\" fxLayout=\"row\" fxLayoutAlign=\"space-between stretch\"\r\n     [@cbpToolbarScrollState]=\"cbpToolbarScrollState\">\r\n\r\n  <div class=\"cbp-brand-nav-container\">\r\n    <ng-content select=\".cbp-toolbar-title\"></ng-content>\r\n  </div>\r\n\r\n  <div class=\"cbp-toolbar-main-nav-container\" *ngIf=\"isToolbarExpanded ? false : true\" fxShow=\"false\" fxShow.gt-xs>\r\n    <ng-template [ngTemplateOutlet]=\"cbpToolbarMainNav\"></ng-template>\r\n  </div>\r\n\r\n  <div class=\"cbp-toolbar-right-nav-container\" *ngIf=\"isToolbarExpanded ? false : true\" fxFlex=\"auto\" fxShow=\"false\"\r\n       fxShow.gt-xs>\r\n    <ng-template [ngTemplateOutlet]=\"cbpToolbarRightNav\"></ng-template>\r\n  </div>\r\n\r\n  <div fxFlex=\"auto\" fxFlexOrder.lt-sm=\"1\" class=\"cbp-toolbar-expansion-container\" fxFlexAlign=\"stretch\" fxLayout=\"row\"\r\n       fxLayoutAlign=\"end stretch\" fxHide=\"false\" fxHide.gt-xs>\r\n    <div class=\"cbp-toolbar-expansion\" (click)=\"isToolbarExpanded = ! isToolbarExpanded\">\r\n      <div class=\"cbp-toolbar-expansion-icon\">\r\n        <span class=\"icon-bar\"></span>\r\n        <span class=\"icon-bar\"></span>\r\n        <span class=\"icon-bar\"></span>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<div *ngIf=\"isToolbarExpanded ? true : false\" fxShow=\"false\" fxShow.lt-sm\r\n     [ngStyle]=\"{ top: getToolbarExpansionPanelTop()}\" class=\"cbp-toolbar-expansion-panel\" [@fadeInContent]=\"'showing'\"\r\n     fxLayout=\"column\">\r\n  <ng-template [ngTemplateOutlet]=\"cbpToolbarMainNav\"></ng-template>\r\n  <ng-template [ngTemplateOutlet]=\"cbpToolbarRightNav\"></ng-template>\r\n</div>\r\n<ng-template #cbpToolbarMainNav>\r\n  <ng-content select=\".cbp-toolbar-main-nav\"></ng-content>\r\n</ng-template>\r\n<ng-template #cbpToolbarRightNav>\r\n  <div fxLayout=\"column\" fxLayoutAlign=\"end stretch\">\r\n    <ng-content select=\".cbp-toolbar-right-nav\"></ng-content>\r\n  </div>\r\n</ng-template>\r\n",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    animations: [
                        CBPScrollShrinkAnimator.createScrollShrinkTrigger('cbpToolbarScrollState', '*', '-50px'),
                        matSelectAnimations.fadeInContent
                    ],
                    exportAs: 'cbpToolbar',
                    styles: [".cbp-brand-nav-container,.cbp-navbar-item,.cbp-navbar-item-default,cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item{font-size:15px;display:flex;align-content:center;align-items:center;vertical-align:middle;height:50px;padding:0 16px}.cbp-navbar-item,cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item{cursor:pointer}.cbp-navbar-item:focus,.cbp-navbar-item:hover,cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item:focus,cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item:hover{outline:dotted thin;outline-offset:-2px;text-decoration:none}.cbp-toolbar-expansion-container .cbp-toolbar-expansion:hover,.cbp-toolbar-expansion-container:hover{outline:0}.cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon{border:1px solid #ddd;position:relative;margin:0;cursor:inherit;padding:9px 10px;border-radius:2px;min-width:inherit;background-color:#f8f8f8}.cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:hover{background-color:#ddd}.cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:focus{border-color:#ddd;outline:#fff dotted 1px!important}.icon-bar+.icon-bar{margin-top:4px}.icon-bar{background-color:#888;display:block;width:22px;height:2px;border-radius:1px}cbp-toolbar{width:100%}cbp-toolbar .cbp-toolbar-row{white-space:nowrap;width:100%;border-bottom:1px solid #adadad}cbp-toolbar .cbp-toolbar-expansion{padding:4px}cbp-toolbar .cbp-toolbar-expansion-panel{position:fixed;background-color:#003e65;color:#fff;border-bottom-color:#003456;z-index:1100;width:100%;top:98px;left:0}cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item{cursor:pointer}cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item .cbp-applications-link{text-decoration:none;color:#333;overflow:inherit;text-overflow:inherit}cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item .cbp-applications-link:focus,cbp-toolbar .cbp-toolbar-expansion-panel .mat-menu-item .cbp-applications-link:hover{text-decoration:underline}.cbp-brand-nav-container{display:block;padding:inherit}.cbp-toolbar-main-nav-container{overflow:hidden}"]
                }] }
    ];
    /** @nocollapse */
    CBPToolbarComponent.ctorParameters = function () { return [
        { type: MediaObserver },
        { type: ChangeDetectorRef }
    ]; };
    CBPToolbarComponent.propDecorators = {
        cbpToolbarScrollState: [{ type: Output }],
        position: [{ type: Input }],
        role: [{ type: HostBinding, args: ['attr.role',] }],
        toolbarState: [{ type: Input }],
        hideToolbarItem: [{ type: Output }],
        scrolled: [{ type: HostListener, args: ['window:scroll', ['$event'],] }]
    };
    return CBPToolbarComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPToolbarModule = /** @class */ (function () {
    function CBPToolbarModule() {
    }
    CBPToolbarModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, FlexLayoutModule, BrowserAnimationsModule
                    ],
                    declarations: [CBPToolbarComponent],
                    exports: [CBPToolbarComponent]
                },] }
    ];
    return CBPToolbarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPFeedbackModule = /** @class */ (function () {
    function CBPFeedbackModule() {
    }
    CBPFeedbackModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, FlexLayoutModule, MatButtonModule, MatIconModule
                    ],
                    declarations: [CBPFeedbackLinkComponent],
                    exports: [CBPFeedbackLinkComponent],
                },] }
    ];
    return CBPFeedbackModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPHeaderModule = /** @class */ (function () {
    function CBPHeaderModule() {
    }
    CBPHeaderModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatListModule,
                        MatMenuModule,
                        MatToolbarModule,
                        FlexLayoutModule,
                        MatIconModule,
                        MatButtonModule,
                        CBPUserModule,
                        CBPApplicationsModule,
                        CBPToolbarModule,
                        CBPFeedbackModule
                    ],
                    declarations: [CBPHeaderComponent],
                    exports: [
                        CBPHeaderComponent,
                        MatButtonModule,
                        CBPUserModule,
                        CBPApplicationsModule,
                        CBPToolbarModule,
                        CBPFeedbackModule
                    ],
                    providers: [{ provide: CBP_HEADER_STATE, useClass: CBPToolbarState }]
                },] }
    ];
    return CBPHeaderModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPRootModule = /** @class */ (function () {
    function CBPRootModule(mdIconRegistry) {
        mdIconRegistry.registerFontClassAlias('fontawesome', 'fa');
    }
    CBPRootModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatIconModule,
                        BrowserAnimationsModule,
                        FlexLayoutModule,
                        MatButtonModule,
                        MatInputModule,
                        MatFormFieldModule,
                        FormsModule
                    ],
                    declarations: [CBPRootComponent],
                    exports: [
                        MatIconModule,
                        BrowserAnimationsModule,
                        FlexLayoutModule,
                        MatButtonModule,
                        MatInputModule,
                        MatFormFieldModule,
                        FormsModule,
                        MatDividerModule,
                        CBPRootComponent,
                        CBPProgressModule,
                        CBPHeaderModule,
                        CBPPipesModule
                    ]
                },] }
    ];
    /** @nocollapse */
    CBPRootModule.ctorParameters = function () { return [
        { type: MatIconRegistry }
    ]; };
    return CBPRootModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPAppHeaderComponent = /** @class */ (function () {
    function CBPAppHeaderComponent(toolbarState, _cdr) {
        this.toolbarState = toolbarState;
        this._cdr = _cdr;
        this.subscriptions = new Subscription();
    }
    /**
     * @return {?}
     */
    CBPAppHeaderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.appHeaderState = 'initial';
        this.subscriptions.add(this.toolbarState.scrollState.subscribe((/**
         * @param {?} state
         * @return {?}
         */
        function (state$$1) {
            _this.appHeaderState = state$$1 ? state$$1 : 'initial';
            _this._cdr.markForCheck();
        })));
    };
    /**
     * @return {?}
     */
    CBPAppHeaderComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.subscriptions.unsubscribe();
    };
    CBPAppHeaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-app-header',
                    template: "<cbp-toolbar position=\"1\" [toolbarState]=\"toolbarState\" class=\"cbp-app-header\" fxLayout=\"row\"\r\n             fxLayoutAlign.gt-xs=\"start stretch\" [@appHeaderState]=\"appHeaderState\">\r\n\r\n  <div class=\"app-header-title-container cbp-toolbar-title\">\r\n    <ng-content select=\".cbp-app-title\"></ng-content>\r\n  </div>\r\n\r\n\r\n  <div class=\"app-header-left-nav-container cbp-toolbar-main-nav\">\r\n    <ng-content select=\".cbp-app-main-nav\"></ng-content>\r\n  </div>\r\n\r\n\r\n  <div class=\"app-header-right-nav-container cbp-toolbar-right-nav\" fxFlex=\"auto\" fxFlexAlign.gt-xs=\"end\"\r\n       fxLayoutAlign.gt-xs=\"end stretch\" fxLayout.gt-xs=\"row\" fxLayout.lt-sm=\"column\">\r\n    <ng-content select=\".cbp-app-right-nav\"></ng-content>\r\n  </div>\r\n\r\n\r\n</cbp-toolbar>\r\n\r\n\r\n\r\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    animations: [
                        CBPScrollShrinkAnimator.createScrollShrinkTrigger('appHeaderState', '50px', '0')
                    ],
                    styles: [":host cbp-toolbar{border-bottom-color:#e7e7e7;height:49px;z-index:1000;position:fixed}:host cbp-toolbar .cbp-toolbar-row{z-index:1000;border-bottom:1px solid #adadad!important}:host cbp-toolbar .cbp-brand-nav-container{cursor:default}:host cbp-toolbar .cbp-brand-nav-container:focus,:host cbp-toolbar .cbp-brand-nav-container:hover{outline:0;outline-offset:initial;text-decoration:initial}:host .cbp-toolbar-expansion-container{z-index:1100}:host .cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon{border:1px solid #ddd;background-color:#f8f8f8}:host .cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:hover{background-color:#ddd}:host .cbp-toolbar-expansion-container .cbp-toolbar-expansion .cbp-toolbar-expansion-icon:focus{border-color:#ddd;outline:#acacac dotted 1px!important}"]
                }] }
    ];
    /** @nocollapse */
    CBPAppHeaderComponent.ctorParameters = function () { return [
        { type: CBPToolbarState, decorators: [{ type: Inject, args: [APP_HEADER_STATE,] }] },
        { type: ChangeDetectorRef }
    ]; };
    CBPAppHeaderComponent.propDecorators = {
        appHeaderState: [{ type: Output }]
    };
    return CBPAppHeaderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPAppHeaderModule = /** @class */ (function () {
    function CBPAppHeaderModule() {
    }
    CBPAppHeaderModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, MatTabsModule, MatListModule, MatMenuModule, MatToolbarModule, FlexLayoutModule, MatButtonModule, MatIconModule,
                        CBPToolbarModule
                    ],
                    declarations: [CBPAppHeaderComponent],
                    exports: [CBPAppHeaderComponent],
                    providers: [{ provide: APP_HEADER_STATE, useClass: CBPToolbarState }]
                },] }
    ];
    return CBPAppHeaderModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MockApplicationsService = /** @class */ (function (_super) {
    __extends(MockApplicationsService, _super);
    function MockApplicationsService(userService) {
        var _this = _super.call(this) || this;
        _this.userService = userService;
        _this.subject = new ReplaySubject(1);
        _this.loaded = false;
        _this.data = new CBPApplicationsData();
        return _this;
    }
    /**
     * @return {?}
     */
    MockApplicationsService.prototype.getApplicationsData = /**
     * @return {?}
     */
    function () {
        return this._load(false);
    };
    /**
     * @return {?}
     */
    MockApplicationsService.prototype.refresh = /**
     * @return {?}
     */
    function () {
        return this._load(true).pipe(map((/**
         * @return {?}
         */
        function () { return true; })));
    };
    /**
     * @param {?} token
     * @return {?}
     */
    MockApplicationsService.prototype.search = /**
     * @param {?} token
     * @return {?}
     */
    function (token) {
        token = token.toLowerCase();
        /** @type {?} */
        var appData = this.data;
        if (appData && appData.list) {
            return appData.list.filter((/**
             * @param {?} app
             * @return {?}
             */
            function (app) {
                return (app.name.toLowerCase().indexOf(token)) >= 0;
            }));
        }
        return [];
    };
    /**
     * @param {?} recentApplication
     * @return {?}
     */
    MockApplicationsService.prototype.removeRecentApplication = /**
     * @param {?} recentApplication
     * @return {?}
     */
    function (recentApplication) {
        return this._removeAppFromArray(recentApplication, this.data.recents);
    };
    /**
     * @private
     * @param {?} app
     * @param {?} fromArray
     * @return {?}
     */
    MockApplicationsService.prototype._removeAppFromArray = /**
     * @private
     * @param {?} app
     * @param {?} fromArray
     * @return {?}
     */
    function (app, fromArray) {
        /** @type {?} */
        var index = fromArray.indexOf(app);
        if (index >= 0) {
            fromArray.splice(index, 1);
        }
        return null;
    };
    /**
     * @private
     * @return {?}
     */
    MockApplicationsService.prototype._getMockHttpData = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var rawList = [];
        /** @type {?} */
        var count = 100;
        do {
            rawList.push({
                id: "" + count,
                name: "App " + count, description: "Description " + count, href: "http://example.com/app-" + count
            });
        } while (count-- >= 0);
        /** @type {?} */
        var data = new CBPApplicationsData();
        data.list = (/** @type {?} */ (rawList));
        return of(data).pipe(delay(2000));
    };
    /**
     * @private
     * @param {?=} force
     * @return {?}
     */
    MockApplicationsService.prototype._load = /**
     * @private
     * @param {?=} force
     * @return {?}
     */
    function (force) {
        var _this = this;
        if (force === void 0) { force = false; }
        if (force || !this.loaded) {
            this.loaded = true;
            return this._getMockHttpData().pipe(map((/**
             * @param {?} results
             * @return {?}
             */
            function (results) {
                results.lastRetrieved = new Date();
                results.currentApp = (/** @type {?} */ ({ name: 'Kitchen Sink' }));
                _this.data = results;
                _this.currentApp.next(results.currentApp);
                return results;
            })), switchMap((/**
             * @param {?} results
             * @return {?}
             */
            function (results) {
                return _this.userService.getUser()
                    .pipe(map((/**
                 * @param {?} user
                 * @return {?}
                 */
                function (user) {
                    return _this._applyUserToApplications(user, results);
                })));
            })));
        }
        return of(this.data);
    };
    /**
     * Fakeology - it does not even use user object
     * @param CBPUser user
     * @param CBPApplicationsData data
     * @returns CBPApplicationsData
     */
    /**
     * Fakeology - it does not even use user object
     * @private
     * @param {?} user
     * @param {?} data
     * @return {?} CBPApplicationsData
     */
    MockApplicationsService.prototype._applyUserToApplications = /**
     * Fakeology - it does not even use user object
     * @private
     * @param {?} user
     * @param {?} data
     * @return {?} CBPApplicationsData
     */
    function (user, data) {
        /** @type {?} */
        var applications = (/** @type {?} */ (data.list));
        if (applications) {
            /** @type {?} */
            var random = void 0;
            data.recents = [];
            data.favorites = [];
            if (user && user.preferences) {
                data.favorites = this._getFavoritesFromUserPreferences(applications, user.preferences.favoriteAppIds);
            }
            // randomly assign few a favorites and some as recent
            random = this._randomIndex(0, applications.length / 10);
            data.recents.push(applications[random]);
            random = this._randomIndex(applications.length / 10, 2 * applications.length / 10);
            data.recents.push(applications[random]);
        }
        return data;
    };
    /**
     * @private
     * @param {?} min
     * @param {?} max
     * @return {?}
     */
    MockApplicationsService.prototype._randomIndex = /**
     * @private
     * @param {?} min
     * @param {?} max
     * @return {?}
     */
    function (min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };
    /**
     * @private
     * @param {?} applications
     * @param {?} userFavoriteAppIds
     * @return {?}
     */
    MockApplicationsService.prototype._getFavoritesFromUserPreferences = /**
     * @private
     * @param {?} applications
     * @param {?} userFavoriteAppIds
     * @return {?}
     */
    function (applications, userFavoriteAppIds) {
        if (!userFavoriteAppIds || !applications) {
            return [];
        }
        /** @type {?} */
        var favorites = applications.filter((/**
         * @param {?} application
         * @return {?}
         */
        function (application) {
            return userFavoriteAppIds.indexOf(application.id) >= 0;
        }));
        return favorites;
    };
    MockApplicationsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    MockApplicationsService.ctorParameters = function () { return [
        { type: CBPUserService, decorators: [{ type: Inject, args: [CBP_USER_SERVICE,] }] }
    ]; };
    return MockApplicationsService;
}(CBPApplicationsService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MockUserService = /** @class */ (function (_super) {
    __extends(MockUserService, _super);
    function MockUserService() {
        var _this = _super.call(this) || this;
        _this.subject = new ReplaySubject();
        _this.loggedIn = false;
        return _this;
    }
    /**
     * @return {?}
     */
    MockUserService.prototype.getUser = /**
     * @return {?}
     */
    function () {
        return this.subject;
    };
    /**
     * @param {?=} delay
     * @return {?}
     */
    MockUserService.prototype.login = /**
     * @param {?=} delay
     * @return {?}
     */
    function (delay$$1) {
        var _this = this;
        if (delay$$1 === void 0) { delay$$1 = 3000; }
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.loggedIn = true;
            /** @type {?} */
            var user = new CBPUser();
            user.firstName = 'First';
            user.lastName = 'LastName';
            user.preferences = {
                favoriteAppIds: _this._randomlyGetFavoritAppId()
            };
            _this.subject.next(user);
            // this.subject.complete();
        }), delay$$1);
        return this.subject;
    };
    /**
     * @return {?}
     */
    MockUserService.prototype.logout = /**
     * @return {?}
     */
    function () {
        this.loggedIn = false;
        this.subject.next(null);
        console.log('mock logout');
    };
    /**
     * @return {?}
     */
    MockUserService.prototype.isLoggedIn = /**
     * @return {?}
     */
    function () {
        return this.loggedIn;
    };
    /**
     * @private
     * @return {?}
     */
    MockUserService.prototype._randomlyGetFavoritAppId = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var favoriteIds = [];
        /** @type {?} */
        var count = 2;
        do {
            favoriteIds.push('' + Math.floor(Math.random() * 10));
        } while (count-- >= 0);
        return favoriteIds;
    };
    MockUserService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    MockUserService.ctorParameters = function () { return []; };
    return MockUserService;
}(CBPUserService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MockFeedbackService = /** @class */ (function () {
    function MockFeedbackService() {
    }
    /**
     * @return {?}
     */
    MockFeedbackService.prototype.handleFeedback = /**
     * @return {?}
     */
    function () {
        console.log('mock feedback clicked');
    };
    /**
     * @param {?} done
     * @return {?}
     */
    MockFeedbackService.prototype.onFeedbackClose = /**
     * @param {?} done
     * @return {?}
     */
    function (done) {
        if (done) {
            done();
        }
    };
    MockFeedbackService.decorators = [
        { type: Injectable }
    ];
    return MockFeedbackService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPMockServicesModule = /** @class */ (function () {
    function CBPMockServicesModule() {
    }
    CBPMockServicesModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    providers: [MockApplicationsService, MockUserService, MockFeedbackService]
                },] }
    ];
    return CBPMockServicesModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var notificationCounter = 0;
var CBPNotification = /** @class */ (function () {
    /**
     * Creates notification
     */
    function CBPNotification(options) {
        this._isOpen$ = new BehaviorSubject(false);
        this.isOpen$ = this._isOpen$.asObservable();
        this._onCloseHandlers = [];
        this.autoClose = false;
        this.autoCloseInMilliSec = 5000;
        this.type = options.type;
        this.message = options.message;
        this.content = options.content;
        this.contentPortal = options.contentPortal;
        this.autoClose = !!options.autoClose;
        this.autoCloseInMilliSec = options.autoCloseInMilliSec;
        this._id = ++notificationCounter;
        this._isOpen$.next(options.isClosedInitially);
    }
    Object.defineProperty(CBPNotification.prototype, "id", {
        get: /**
         * @return {?}
         */
        function () {
            return this._id;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Is the notification currently open ?
     */
    /**
     * Is the notification currently open ?
     * @return {?}
     */
    CBPNotification.prototype.isOpen = /**
     * Is the notification currently open ?
     * @return {?}
     */
    function () {
        return this._isOpen$.getValue();
    };
    /**
     * Open the notification that is created.
     */
    /**
     * Open the notification that is created.
     * @return {?}
     */
    CBPNotification.prototype.open = /**
     * Open the notification that is created.
     * @return {?}
     */
    function () {
        this._isOpen$.next(true);
    };
    /**
     * Close the notification. Meant for close and destroy.
     */
    /**
     * Close the notification. Meant for close and destroy.
     * @return {?}
     */
    CBPNotification.prototype.close = /**
     * Close the notification. Meant for close and destroy.
     * @return {?}
     */
    function () {
        var _this = this;
        this._isOpen$.next(false);
        this._onCloseHandlers.forEach((/**
         * @param {?} h
         * @param {?} index
         * @return {?}
         */
        function (h, index) {
            if (h) {
                _this._onCloseHandlers.splice(index, 1);
                try {
                    h();
                }
                catch (err) {
                    console.log(err);
                }
            }
        }));
    };
    /**
     * OnClose handler
     */
    /**
     * OnClose handler
     * @param {?} handler
     * @return {?}
     */
    CBPNotification.prototype.onClose = /**
     * OnClose handler
     * @param {?} handler
     * @return {?}
     */
    function (handler) {
        if (this._onCloseHandlers.indexOf(handler) < 0) {
            this._onCloseHandlers.push(handler);
        }
        return this;
    };
    return CBPNotification;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPNotificationComponent = /** @class */ (function () {
    function CBPNotificationComponent(animationBuilder, elementRef) {
        this.animationBuilder = animationBuilder;
        this.elementRef = elementRef;
        this.type = 'info';
        this.autoShow = false;
        this.delay = 100;
        this.show = false;
        this._subscriptions = new Subscription();
        this.close = new EventEmitter();
    }
    /**
     * @return {?}
     */
    CBPNotificationComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (!this.notification) {
            this.notification = new CBPNotification({ isClosedInitially: this.autoShow });
            if (!this.notification.message) {
                this.notification.message = this.message;
            }
            if (!this.notification.type) {
                this.notification.type = this.type;
            }
        }
        else if (!this.notification.open) {
            throw new Error('Must be an instance of CBPNotification');
        }
        this._subscriptions.add(this.notification.isOpen$.subscribe((/**
         * @param {?} state
         * @return {?}
         */
        function (state$$1) {
            if (state$$1) {
                _this.activate();
            }
            else {
                _this.remove();
            }
        })));
    };
    /**
     * @return {?}
     */
    CBPNotificationComponent.prototype.startAutoClose = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.notification.autoClose) {
            /** @type {?} */
            var autoCloseAnimation = this.animationBuilder.build(query('.toast-color', [
                animate(this.notification.autoCloseInMilliSec + "ms linear", style({
                    transform: 'scaleY(0)',
                }))
            ], { optional: true }));
            this.autoClosePlayer = autoCloseAnimation.create(this.elementRef.nativeElement);
            this.autoClosePlayer.onDone((/**
             * @return {?}
             */
            function () { return _this.notification.close(); }));
            this.autoClosePlayer.play();
        }
    };
    /**
     * @return {?}
     */
    CBPNotificationComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._subscriptions.unsubscribe();
        if (this.autoClosePlayer) {
            this.autoClosePlayer.destroy();
        }
    };
    /**
     * @return {?}
     */
    CBPNotificationComponent.prototype.activate = /**
     * @return {?}
     */
    function () {
        this.show = true;
        this.animationState = 'enter';
    };
    /**
     * @return {?}
     */
    CBPNotificationComponent.prototype.dismiss = /**
     * @return {?}
     */
    function () {
        this.show = false;
        this.animationState = 'leave';
    };
    /**
     * @param {?=} userTriggered
     * @return {?}
     */
    CBPNotificationComponent.prototype.remove = /**
     * @param {?=} userTriggered
     * @return {?}
     */
    function (userTriggered) {
        var _this = this;
        this.dismiss();
        if (userTriggered) {
            this.notification.close();
        }
        EMPTY.pipe(delay(300)).subscribe(null, null, (/**
         * @return {?}
         */
        function () {
            _this.close.emit(_this.notification);
        }));
    };
    CBPNotificationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-notification',
                    template: "<div (@animationState.done)=\"startAutoClose()\" *ngIf=\"show\" [@animationState]=\"animationState\"\r\n     [ngClass]=\"'toast-'+notification?.type\"\r\n     aria-live=\"polite\" class=\"toast\"\r\n     tabindex=\"-1\"><span class=\"cdk-visually-hidden\">{{ notification?.type }} notification</span>\r\n  <div class=\"toast-color\"></div>\r\n  <div class=\"toast-body\">\r\n    <button (click)=\"remove(true)\" aria-label=\"Close\" class=\"close\" mat-icon-button>\r\n      <mat-icon fontIcon=\"fa-close\" fontSet=\"fontawesome\"></mat-icon>\r\n    </button>\r\n    <ng-container *ngIf=\"notification.message\">\r\n      <span class=\"cbp-notification-contents\">{{ notification.message }}</span>\r\n    </ng-container>\r\n    <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n",
                    encapsulation: ViewEncapsulation.None,
                    animations: [
                        trigger('animationState', [
                            transition('* => enter', [
                                style({ transform: 'translateX(100%)', opacity: 0 }),
                                animate('500ms', style({ transform: 'translateX(0)', opacity: 1 }))
                            ]),
                            transition('enter => *', [
                                style({ transform: 'translateX(0)', opacity: 1 }),
                                animate('500ms', style({ transform: 'translateX(100%)', opacity: 0 }))
                            ])
                        ])
                    ],
                    styles: [".toast{margin-bottom:9px;position:relative;background:#fff;box-shadow:0 1px 3px rgba(0,0,0,.1);flex-direction:row;box-sizing:border-box;display:flex;flex:1 1 100%;min-height:40px}.toast button.close{position:absolute;right:0;top:0;opacity:.6}.toast-info .toast-color{background:#1460aa}.toast-primary .toast-color{background:#00416a}.toast-success .toast-color{background:green}.toast-danger .toast-color{background:#a00000}.toast-warning .toast-color{background:#f09511}.toast-color{place-content:center;align-items:center;flex-direction:row;box-sizing:border-box;display:flex;flex:1 1 100%;max-width:8px;z-index:1;-webkit-transform-origin:bottom center;transform-origin:bottom center}.toast-body{height:100%;width:calc(100% - 8px);flex:1 1 100%;padding:12px;border:1px solid #ddd;border-radius:0 2px 2px 0;border-left:none}.toast::before{content:\"\";position:absolute;height:100%;width:8px}.toast.toast-info::before{background:#c5dff8}.toast.toast-primary::before{background:#6ac5ff}.toast.toast-success::before{background:#80ff80}.toast.toast-danger::before{background:#ffa0a0}.toast.toast-warning::before{background:#f5b559}.cbp-notification-contents{display:inline-block;margin-bottom:6px;margin-right:15px}.cbp-notification-actions{display:inline-block;margin-top:6px;padding-top:0;width:100%}"]
                }] }
    ];
    /** @nocollapse */
    CBPNotificationComponent.ctorParameters = function () { return [
        { type: AnimationBuilder },
        { type: ElementRef }
    ]; };
    CBPNotificationComponent.propDecorators = {
        type: [{ type: Input }],
        message: [{ type: Input }],
        notification: [{ type: Input }],
        autoShow: [{ type: Input }],
        delay: [{ type: Input }],
        show: [{ type: Input }],
        close: [{ type: Output }]
    };
    return CBPNotificationComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPNotificationsService = /** @class */ (function () {
    function CBPNotificationsService() {
        this._notifications$ = new ReplaySubject(3);
    }
    /**
     * @return {?}
     */
    CBPNotificationsService.prototype.getNotifications = /**
     * @return {?}
     */
    function () {
        return this._notifications$.asObservable();
    };
    /**
     * Adds and opens a notification.
     * @param CBPNotification notification
     */
    /**
     * Adds and opens a notification.
     * @param {?} notification
     * @return {?}
     */
    CBPNotificationsService.prototype.notify = /**
     * Adds and opens a notification.
     * @param {?} notification
     * @return {?}
     */
    function (notification) {
        notification.open();
        this._notifications$.next(notification);
    };
    /**
     * Snoozes a notification
     * @param CBPNotification notification
     * @param number wakeUpAfter
     */
    /**
     * Snoozes a notification
     * @param {?} notification
     * @param {?=} wakeUpAfter
     * @return {?}
     */
    CBPNotificationsService.prototype.snooze = /**
     * Snoozes a notification
     * @param {?} notification
     * @param {?=} wakeUpAfter
     * @return {?}
     */
    function (notification, wakeUpAfter) {
        var _this = this;
        if (wakeUpAfter === void 0) { wakeUpAfter = 5000; }
        notification.close();
        EMPTY.pipe(delay(wakeUpAfter)).subscribe(null, null, (/**
         * @return {?}
         */
        function () {
            _this.notify(notification);
        }));
    };
    CBPNotificationsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    CBPNotificationsService.ctorParameters = function () { return []; };
    return CBPNotificationsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPNotificationsOverlayComponent = /** @class */ (function () {
    function CBPNotificationsOverlayComponent(notificationsService, viewContainerRef) {
        this.notificationsService = notificationsService;
        this.viewContainerRef = viewContainerRef;
        this.notifications = [];
    }
    /**
     * @return {?}
     */
    CBPNotificationsOverlayComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.notifications$ = this.notificationsService.getNotifications().pipe(map((/**
         * @param {?} notification
         * @return {?}
         */
        function (notification) {
            if (notification.content && !notification.contentPortal) {
                notification.contentPortal = new TemplatePortal(notification.content, _this.viewContainerRef);
            }
            _this.notifications.push(notification);
            return _this.notifications;
        })));
    };
    /**
     * @param {?} closed
     * @return {?}
     */
    CBPNotificationsOverlayComponent.prototype.onClose = /**
     * @param {?} closed
     * @return {?}
     */
    function (closed) {
        closed.close();
        /** @type {?} */
        var index = this.notifications.indexOf(closed);
        this.notifications.splice(index, 1);
    };
    CBPNotificationsOverlayComponent.decorators = [
        { type: Component, args: [{
                    selector: 'cbp-notifications-overlay',
                    template: "<div *ngIf=\"notifications$ | async as allNotifications\" class=\"cbp-notifications-overlay\">\r\n  <cbp-notification (close)=\"onClose($event)\" *ngFor=\"let notification of allNotifications\"\r\n                    [notification]=\"notification\">\r\n    <ng-template [cdkPortalOutlet]=\"notification.contentPortal\"></ng-template>\r\n  </cbp-notification>\r\n</div>\r\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".cbp-notifications-overlay{max-width:500px;width:100%;position:fixed;top:52px;right:0;z-index:10000}"]
                }] }
    ];
    /** @nocollapse */
    CBPNotificationsOverlayComponent.ctorParameters = function () { return [
        { type: CBPNotificationsService },
        { type: ViewContainerRef }
    ]; };
    return CBPNotificationsOverlayComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CBPNotificationsModule = /** @class */ (function () {
    function CBPNotificationsModule() {
    }
    CBPNotificationsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule, MatButtonModule, PortalModule, MatIconModule
                    ],
                    declarations: [CBPNotificationComponent, CBPNotificationsOverlayComponent],
                    exports: [CBPNotificationComponent, CBPNotificationsOverlayComponent],
                    providers: [CBPNotificationsService]
                },] }
    ];
    return CBPNotificationsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CBPToggleSwitchChange, CBPToggleSwitchComponentBase, _CBPToggleSwitchMixinBase, CBPToggleSwitchComponent, CBPButtonsModule, CBPApplicationsData, CBPApplicationsService, CBP_APPLICATIONS_SERVICE, CBPApplicationsModule, CBPApplicationsMenuComponent, CBPApplicationsSearchComponent, CBPRootModule, CBPRootComponent, CBP_HEADER_STATE, APP_HEADER_STATE, CBPToolbarState, HEADER_SHRINK_TRANSITION, CBPScrollShrinkAnimator, CBPToolbarComponent, CBPToolbarModule, CBPAppHeaderModule, CBPAppHeaderComponent, CBPHeaderModule, CBPHeaderComponent, DATE_FORMAT_DayOfWeek_ShortDate_Time, CBPDatetimePipe, CBPPipesModule, CBPUser, CBPUserService, CBP_USER_SERVICE, CBPUserModule, CBPUserMenuComponent, CBPMockServicesModule, MockApplicationsService, MockFeedbackService, MockUserService, CBPNotificationsModule, CBPNotification, CBPNotificationsService, CBPNotificationComponent, CBPNotificationsOverlayComponent, CBPFeedbackService, CBP_FEEDBACK_SERVICE, CBPFeedbackModule, CBPFeedbackLinkComponent, CBPProgressModule, CBPLoadingComponent };

//# sourceMappingURL=ngx-cbp-theme.js.map