import { ChangeDetectorRef, ElementRef, EventEmitter, OnInit } from '@angular/core';
import { CanColor, CanDisable, HasTabIndex, ThemePalette } from '@angular/material/core';
import { ControlValueAccessor } from '@angular/forms';
export declare class CBPToggleSwitchChange {
    checked: boolean;
    source: CBPToggleSwitchComponent;
}
export declare class CBPToggleSwitchComponentBase {
    _elementRef: ElementRef;
    constructor(_elementRef: ElementRef);
}
export declare const _CBPToggleSwitchMixinBase: import("@angular/material/core/typings/common-behaviors/constructor").Constructor<HasTabIndex> & import("@angular/material/core/typings/common-behaviors/constructor").Constructor<CanColor> & import("@angular/material/core/typings/common-behaviors/constructor").Constructor<CanDisable> & typeof CBPToggleSwitchComponentBase;
export declare class CBPToggleSwitchComponent extends _CBPToggleSwitchMixinBase implements OnInit, CanColor, CanDisable, ControlValueAccessor, HasTabIndex {
    private _changeDetectorRef;
    ariaLabel: string;
    ariaLabelledby: string | null;
    onValue: any;
    offValue: any;
    onLabel: string;
    offLabel: string;
    label: string;
    disabled: boolean;
    color: ThemePalette;
    name: string | null;
    tabIndex: number;
    className: string;
    id: string;
    _checked: Boolean;
    required: boolean;
    private _required;
    inputId: string;
    readonly change: EventEmitter<CBPToggleSwitchChange>;
    constructor(elementRef: ElementRef, _changeDetectorRef: ChangeDetectorRef, tabIndex: string);
    checked: boolean;
    _getAriaChecked(): 'true' | 'false' | 'mixed';
    _stopPropogation($event: Event): void;
    _onClick($event: Event): void;
    private _emitChangeEvent;
    private _controlValueAccessorChangeFn;
    ngOnInit(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    /**
     * Focus control not implemented yet
     */
    registerOnTouched(): void;
    setDisabledState(isDisabled: boolean): void;
}
