import { TemplateRef } from '@angular/core';
import { Portal } from '@angular/cdk/portal';
import { Observable } from 'rxjs';
export declare class CBPNotification {
    private _isOpen$;
    isOpen$: Observable<boolean>;
    private readonly _id;
    private _onCloseHandlers;
    readonly id: number;
    type?: 'success' | 'danger' | 'warning' | 'info';
    message?: string;
    content?: TemplateRef<any>;
    contentPortal?: Portal<any>;
    autoClose: boolean;
    autoCloseInMilliSec: number;
    /**
     * Creates notification
     */
    constructor(options: {
        isClosedInitially?: boolean;
        type?: 'success' | 'danger' | 'warning' | 'info';
        message?: string;
        content?: TemplateRef<any>;
        contentPortal?: Portal<any>;
        autoClose?: boolean;
        autoCloseInMilliSec?: number;
    });
    /**
     * Is the notification currently open ?
     */
    isOpen(): boolean;
    /**
     * Open the notification that is created.
     */
    open(): void;
    /**
     * Close the notification. Meant for close and destroy.
     */
    close(): void;
    /**
     * OnClose handler
     */
    onClose(handler: () => any): CBPNotification;
}
