import { ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { AnimationBuilder, AnimationPlayer } from '@angular/animations';
import { CBPNotification } from '../cbp-notification';
export declare class CBPNotificationComponent implements OnInit, OnDestroy {
    private animationBuilder;
    private elementRef;
    type?: 'success' | 'danger' | 'warning' | 'info';
    message?: string;
    notification: CBPNotification;
    autoShow: boolean;
    delay: number;
    show: boolean;
    animationState: any;
    autoClosePlayer: AnimationPlayer;
    private _subscriptions;
    close: EventEmitter<CBPNotification>;
    constructor(animationBuilder: AnimationBuilder, elementRef: ElementRef);
    ngOnInit(): void;
    startAutoClose(): void;
    ngOnDestroy(): void;
    activate(): void;
    dismiss(): void;
    remove(userTriggered?: boolean): void;
}
